Bug 41974 - RFE: Please add libGLw to Mesa packaging
RFE: Please add libGLw to Mesa packaging
Product: Red Hat Linux
Classification: Retired
Component: Mesa (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Mike A. Harris
Aaron Brown
: 41791 (view as bug list)
Depends On:
  Show dependency treegraph
Reported: 2001-05-23 10:15 EDT by Wayne Price
Modified: 2007-04-18 12:33 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2001-07-31 22:44:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
this is a "diff -u" of the Mesa.spec from Mesa-3.4-13.src.rpm (1.63 KB, patch)
2001-06-29 09:12 EDT, Need Real Name
no flags Details | Diff

  None (edit)
Description Wayne Price 2001-05-23 10:15:45 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.76 [en] (X11; U; Linux 2.2.16-3smp i686)

Description of problem:
The library file libGLw.a (GL widget for Xt and/or Motif) and the
associated header files (GLwDrawA.h, GLwMDrawA.h, etc.)  are missing.

These can be compiled from the Mesa sources by just doing the following:
  cd Mesa-root-source-dir/widgets-mesa

The library file produced is actually called libMesaGLw.a rather than
libGLw.a, but the naming isn't too big a problem.

How reproducible:

Steps to Reproduce:
1. Trying to compile code which uses the GLw widget. Code works on the SGI
platform, but not on Linux.


Actual Results:  Compiler warnings - missing header files, missing symbols
when linking.

Expected Results:  Application builds!

Additional info:
Comment 1 Bernhard Rosenkraenzer 2001-05-23 10:23:40 EDT
libGLw needs Motif to build. We don't ship Motif, so we can't build libGLw.
Comment 2 Wayne Price 2001-05-23 10:48:21 EDT
No... libGLwM.a (the Motif version) requires Motif. To build this, ./configure

libGLw.a requires Xt only. Subtle differences in the builds, but...
Comment 3 Wayne Price 2001-05-23 10:51:13 EDT
Additionally, open-motif ships with powertools. Maybe I should've logged this
under powertools, not redhat?
Comment 4 Mike A. Harris 2001-06-02 03:56:41 EDT
OpenMotif is hitting the road.  The license on it is too restrictive.
Lesstif will remain, but is only partially functional as a replacement.
For new development, Motif is totally dead - or should be.  Thus it doesn't
make any sense to enable a Motif library that hasn't existed in our dist
before now.  Any new development should be done with GTK or Qt, etc..
Motif is just not a sensible widget set IMHO to work with nowadays.

That said, I don't consider this a bug, but rather a request for enhancement.
I just closed another bug report on this issue by removing the GLw manpages
from our X packaging.  Unless there is a real good reason for enabling the
GLw Xt version of this library, I'm inclined to leave it out.  What application
requires this?
Comment 5 Mike A. Harris 2001-06-03 23:05:33 EDT
*** Bug 41791 has been marked as a duplicate of this bug. ***
Comment 6 Mike A. Harris 2001-06-04 03:18:35 EDT
I've updated the summary to match the report.  What important apps do you
need this support for that it is considered critical for you (anyone)?  Where
can I find some apps to test this with?  Open source of course, and prefereably
in src.rpm format.  I'll test it out and consider adding it later.
Comment 7 Wayne Price 2001-06-04 04:11:56 EDT
While you say it doesn't make sense to support Motif (not sensible as you say),
there is the case that there are many applications written for Sun and Silicon
Graphics machines which use Motif and libGLw on those platforms. This is where I
am coming from. The applications I am working on are being ported from those
platforms to Linux, and additional enhancements made. It is not commercially
viable to use Qt and/or GTK. Since Motif is supported on Linux (either via
lesstif or open-motif), it makes sense to add the libGLw widget aswell.

Unfortunately, I have no details of RPM source code to test this out with. As
you can tell from above the applications I work with are not open-source and I
can't release any parts to you. I will, however, try to find some applications
which make use of libGLw, and which are open-source.

As a starting point, the Mesa library has some demo programs in the
widgets-mesa/demos sub-directory.
Comment 8 Need Real Name 2001-06-06 01:54:36 EDT
The one important application I have in mind is OpenInventor
(http://oss.sgi.com/projects/inventor) and I definitely don't support the
leave-it-out-because-it's-not-gtk/Qt-approach. While you may argue that new
development should be done with gtk or Qt, reality is that a lot of legacy code
is being ported from other unices in order to start using Linux. - And in this
context libGLw *is* important. 

As for where it goes, I know that it lives in XFree86-devel on mandrake, and it
is my impression that Mesa has been folded into XFree86 as of version 4.0 and
later. Hence my initial request to add it to the XFree package. However, since
it's pretty much selfcontained, why not create a separate little package for it
? That way,. purist don't have to bother with it, and those who need it can
easily get it.
Comment 9 Need Real Name 2001-06-28 10:44:14 EDT
I am writing to simply add support to the arguement that one cannot just port
code from Motif to GTK or QT.  There is a great deal of legacy code out there in
industry using open motif  (our company being one of them).  The current
tarballs of Mesa (3.4?) build libMesaGLw.a (ie: a renamed version of libGLw.a,
but it does link with older apps) and installs the missing header files.  If
Mesa still supports this, i think it should be included in the RedHat Mesa RPM. 
Perhaps i'm missing something, but i dont see the problem in adding another 5
lines, to include the missing files, in the "mesa.spec" file when rebuilding the
Comment 10 Mike A. Harris 2001-06-28 11:35:43 EDT
Ok, I've decided that I will add this stuff.  It is not a high priority item
though, so I don't know when I'll get to it.  If you take the latest
Mesa src.rpm, and make a patch to the specfile and attach it to the bug
report as a file attachment, it will likely get in sooner than later.

Please use "diff -u" to generate the diff if you do.  Also, only the non-motif
version of libGLw.  We do not ship openmotif any longer due to licencing issues,
and lesstif is only there as a priority 3 package.  I won't add additional
Motif support without very compelling reasons.  the Xt lib should IMHO suffice.

Also, just for your information about porting from Motif to Gtk/QT.  When
Netscape sources were released to the public it took the TrollTech guys about
6 days to port Netscape to Qt.  That is about 6 guys and 6 days.  So...  ;o)
Comment 11 Need Real Name 2001-06-29 09:12:43 EDT
Created attachment 22207 [details]
this is a "diff -u" of the Mesa.spec from  Mesa-3.4-13.src.rpm
Comment 12 Need Real Name 2001-06-29 09:46:03 EDT
This is with regards to my previous email (just sent):

Perhaps not the most elegant fix to the spec file, but I in no way, shape, or 
form claim to be an expert packager.  This change will only the alter Mesa-
devel package.

Thanx for incorporating these files.

Comment 13 Mike A. Harris 2001-07-31 22:44:46 EDT
Your diff was made backwards.  ;o)  For diffing, in general you make a copy
of the original first, something like "cp Mesa.spec Mesa.spec.orig", then
edit the spec, so your new one is just Mesa.spec, and then you diff with:

diff -u Mesa.spec.orig Mesa.spec > Mesa.spec.diff

Sorry for the confusion.  I have looked into the GLw stuff that comes
with Mesa, and it appears to be beta software.  The last changelog entries
are from 1995 which does not seem encouraging.  I will have to check the
stability of this before commiting to shipping it.
Comment 14 Mike A. Harris 2001-08-14 10:14:35 EDT
Nevermind... I whipped up the libGLw stuff myself based on your

libGLw added to Mesa-3.4.2-5 epoch 3 for XFree86 4.1.0-0.9.13

It is *TOTALLY* untested.  So *please* test it ASAP to ensure that
the lib works, etc. before our final release.

Put in Rawhide, and also available on my ftp site:

Comment 15 Mike A. Harris 2002-01-25 10:37:30 EST
Added also to XFree86 4.2.0 builds now.

Note You need to log in before you can comment on or make changes to this bug.